$compile unit

$error all-
$lib all-

defint a-z




' DOS Print, Cursor Line Routines 

'Ŀ
' SUBROUTINE DosPrint(text$)                                                 
'    Uses DOS Interrupt &h21 functions 2 and 9 to print TEXT$ to the         
'    standard output (may be redirected...hey that's the whole point!).      
'    Isolates "$" and splits the printing between function 9 (normal text)   
'    and function 2 (single-character) for the "$".  DOES NOT add a CR-LF    
'    pair; include it in TEXT$ if you want it.                               
'                                                                            
'    **** Be sure to include DosFunc2, DosFunc9 and FindString ****          
'

   SUB DosPrint(text$)  Public
      LOCAL i%,temp$
      IF text$="" THEN EXIT SUB
      temp$=text$
      i%=INSTR(temp$,"$")
      DO UNTIL i%=0
         IF i%>1 THEN CALL DosFunc9(MID$(temp$,1,i%-1))
         CALL DosFunc2("$")
         temp$=MID$(temp$,i%+1)
         i%=INSTR(temp$,"$")
      LOOP
      CALL DosFunc9(temp$)
   END SUB


'Ŀ
' SUBROUTINE DosFunc2(char$)                                                 
'    Prints a single CHAR$ to the standard output device using function 2    
'    of interrupt &h21.  May be redirected.                                  
'                                                                            
'    **** You must use this if you use the DosPrint routine ****             
'

   SUB DosFunc2(char$)  Public
      REG 1,&h0200
      REG 4,ASC(char$)
      CALL INTERRUPT &h21
   END SUB


'Ŀ
' SUBROUTINE DosFunc9(msg$)                                                  
'    Prints a string MSG$ to the standard output device using function 9     
'    of interrupt &h21.  May be redirected.                                  
'                                                                            
'    **** You must use this if you use the DosPrint routine ****             
'    **** This uses FindString -- be sure to include it ****                 
'

   SUB DosFunc9(msg$)  Public
      LOCAL msgseg%,msgoff%
      msg$=msg$+"$"
      CALL FindString(msgseg%,msgoff%,msg$)
      REG 1,&h0900
      REG 4,msgoff%
      REG 8,msgseg%
      CALL INTERRUPT &h21
   END SUB


'Ŀ
' SUBROUTINE FindString(string.seg%,string.off%,find$)                       
'    Returns the segment/offset of the string FIND$.                         
'

   SUB FindString(string.seg%,string.off%,find$)
      LOCAL desc%
      DEF SEG
      string.seg%=PEEK(0)+256*PEEK(1)
      DEF SEG=VARSEG(find$)
      desc%=VARPTR(find$)
      string.off%=PEEK(desc%+2)+256*PEEK(desc%+3)
      DEF SEG
   END SUB