$compile unit

$error all-
$lib all-

defint a-z



' Mouse Status Routines 

'Ŀ
' SUBROUTINE FindMouse(buttons%)                                             
'    Returns the number of mouse BUTTONS% (always 2 for Microsoft Mouse).    
'    Returns 0 if a mouse is not installed.                                  
'

   SUB FindMouse(buttons%) PUBLIC
      REG 1,&h0000
      CALL INTERRUPT &h33
      buttons%=REG(1)
      IF buttons%<>0 THEN buttons%=(REG(2) AND &hFF)
   END SUB


'Ŀ
' SUBROUTINE MouseButtons(leftbutton%,rightbutton%)                          
'    Returns TRUE (-1) or FALSE (0) indicating that a mouse button is        
'    currently being pressed.                                                
'

   SUB MouseButtons(leftbutton%,rightbutton%)  PUBLIC
      LOCAL i%
      REG 1,&h0003
      CALL INTERRUPT &h33
      i%=REG(2)
      leftbutton%=((i% AND 1)=1)
      rightbutton%=((i% AND 2)=2)
   END SUB


'Ŀ
' SUBROUTINE MouseClicked(leftbutton%,rightbutton%)                          
'    Returns TRUE/FALSE indicating the mouse buttons which have been         
'    clicked since the routine was last called.  Resets both flags to 0      
'    after the call.                                                         
'

   SUB MouseClicked(leftbutton%,rightbutton%)  PUBLIC
      LOCAL i%
      REG 1,&h0005
      CALL INTERRUPT &h33
      i%=REG(1)
      leftbutton%=((i% AND 1)=1)
      rightbutton%=((i% AND 2)=2)
   END SUB


'Ŀ
' SUBROUTINE MouseCursorOn                                                   
'    Turns on the mouse cursor.                                              
'

   SUB MouseCursorOn  PUBLIC
      REG 1,&h0001
      CALL INTERRUPT &h33
   END SUB


'Ŀ
' SUBROUTINE MouseCursorOff                                                  
'    Turns off (hides) the mouse cursor.                                     
'

   SUB MouseCursorOff  PUBLIC
      REG 1,&h0002
      CALL INTERRUPT &h33
   END SUB


'Ŀ
' SUBROUTINE GetMouseLocation(mouse.col%,mouse.row%)                         
'    Returns the X,Y position of the mouse in units for the current video    
'    mode.                                                                   
'

   SUB GetMouseLocation(mouse.col%,mouse.row%)  PUBLIC
      REG 1,&h0003
      CALL INTERRUPT &h33
      mouse.col%=REG(3)
      mouse.row%=REG(4)
   END SUB


'Ŀ
' SUBROUTINE SetMouseLocation(mouse.col%,mouse.row%)                         
'    Set the on-screen location of the mouse in units for current video      
'    mode.                                                                   
'

   SUB SetMouseLocation(mouse.col%,mouse.row%)  PUBLIC
      REG 3,mouse.col%
      REG 4,mouse.row%
      REG 1,&h0003
      CALL INTERRUPT &h33
   END SUB


'Ŀ
' SUBROUTINE SetMouseWindow(min.col%,min.row%,max.col%,max.row%)             
'    Set a window limiting mouse movement in units for the current video     
'    mode.                                                                   
'

   SUB SetMouseWindow(min.col%,min.row%,max.col%,max.row%)  PUBLIC
      LOCAL c1%,c2%,r1%,r2%
      c1%=min.col%
      c2%=max.col%
      IF c2%<c1% THEN SWAP c1%,c2%
      r1%=min.row%
      r2%=max.row%
      IF r2%<r1% THEN SWAP r1%,r2%
      REG 3,c1%
      REG 4,c2%
      REG 1,&h0007
      CALL INTERRUPT &h33
      REG 3,r1%
      REG 4,r2%
      REG 1,&h0008
      CALL INTERRUPT &h33
   END SUB
