$compile unit

$error all-
$lib all-

defint a-z



'Ŀ
' FUNCTION TypeInstr%(start%,text$,RTYPE%)                                    
'    Returns INSTR position in TEXT$ for character of RTYPE% (1=alpha, 2=     
'    numeric, 4=symbol, 8=control, 16=graphics, 32=space).  Can combine      
'    RTYPE%s (1+4+8+16+32 = 61 which is first non-numeric).  Search begins    
'    at START% position within TEXT$.  If START% is more than the length     
'    of TEXT$, or a character of RTYPE% was not found, a 0 is returned.       
'    If TEXT$ is null, RTYPE% is out-of-range, or START% is less than 1 a     
'    -1 is returned as an error flag.                                        
'

FUNCTION TypeInstr%(start%,text$,RTYPE%)  PUBLIC
      LOCAL i%,c%,ctype%
      TypeInstr%=-1
      IF text$="" THEN EXIT FUNCTION
      IF RTYPE%<1 OR RTYPE%>63 THEN EXIT FUNCTION
      IF start%<1 THEN EXIT FUNCTION
      TypeInstr%=0
      IF start%>LEN(text$) THEN EXIT FUNCTION
      FOR i%=start% TO LEN(text$)
         c%=ASC(MID$(text$,i%,1))
         SELECT CASE c%
            CASE 32
               ctype%=32
            CASE > 127
               ctype%=16
            CASE < 32
               ctype%=8
            CASE 48 TO 57
               ctype%=2
            CASE 65 TO 90, 97 TO 122
               ctype%=1
            CASE ELSE
               ctype%=4
         END SELECT
         IF (ctype% AND RTYPE%) THEN
	    TypeInstr%=i%
            EXIT FOR
         END IF
      NEXT
   END FUNCTION